#!/bin/sh
# -*- coding: utf-8 -*-
INSTALL_VERSION="0.9.200908031459"
#
#    *****************************************************************************************************************************************
#  *********************************************************************************************************************************************
# **                                                                                                                                           **
# **                                                                                                                                           **
# **                                                                                                                                           **
# **                                                                                                                                           **
# **         ****                              ****   ***********************************       ***********************************            **
# **         ****                              ****   *************************************     *************************************          **
# **         ****                              ****   **************************************    **************************************         **
# **                                           ****                                      ****   ****                               ****        **
# **         ****                              ****                                      ****   ****                               ****        **
# **         ****                              ****                                      ****   ****                               ****        **
# **         ****                              ****                                      ****   ****                               ****        **
# **         **************************************      ************************************   ****                               ****        **
# **         **************************************     *************************************   ****                               ****        **
# **         **************************************    **************************************   ****                               ****        **
# **         ****                              ****   ****                               ****   ****                               ****        **
# **         ****                              ****   ****                               ****   ****                               ****        **
# **         ****                              ****   ****                               ****   ****                               ****        **
# **         ****                              ****   ****                               ****   ****                               ****        **
# **         ****                              ****   ****                               ****   ****                               ****        **
# **         ****                              ****    **************************************   **************************************         **
# **         ****                              ****     *************************************   *************************************          **
# **         ****                              ****       ***********************************   ***********************************            **
# **                                                                                                                                           **
# **                                                                                                                                           **
# **                                                         www.i-have-a-dreambox.com                                                         **
# **                                                                                                                                           **
#  *********************************************************************************************************************************************
#    *****************************************************************************************************************************************
#
#  Copyright (C) 2008,2009 by adenin
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
###############################################################################
# Installscript für zum automatischen Aufbau der Entwicklungsumgebung zum
# Erstellen von Images folgender Dreamboxtypen:
#	DM500
#	DM5600/DM5620
#	DM500plus
#	DM500hd
#	DM600pvr
#	DM7000
#	DM7020
#	DM7025
#	DM800
#	DM8000
###############################################################################
# Getestes auf:
#	(k)ubundu ab Version 5.10	geht super
#	Fedora 10			geht super
#	SuSE 11.1			geht super
#
#	Mandriva 8	wegen intuitiver Totalunbenutzbarkeit Test abgebrochen
#	Mandriva2009	wegen Fehlverhalten des su-Befehls Test abgebrochhen
###############################################################################
ANSI_BLACK="\033[37;30m"
ANSI_RED="\033[37;31m"
ANSI_GREEN="\033[37;32m"
ANSI_YELLOW="\033[37;33m"
ANSI_BLUE="\033[37;34m"
ANSI_MAGENTA="\033[37;35m"
ANSI_CYAN="\033[37;36m"
ANSI_WITHE="\033[37;37m"
ANSI_RESET="\033[37;39m"
ANSI_RESET2="\033[0m"
###############################################################################
_ihad_logo()
{
B1="\033[40m\E[34m"
B2="\033[40m\E[94m"
B3="\033[40m\E[36m"
B4="\033[40m\E[96m"
R="\033[0m"
Ba="\033[5m"
Bb="\033[25m"
#          |----------------------------------80 Zeichen------------------------------------|
echo -e $B1" ############################################################################## "$R
echo -e $B1"#                               $B2$INSTALL_VERSION$B1                               #"$R
echo -e $B1"#                                                                              #"$R
echo -e $B1"#  ###                  ### #######################  ######################    #"$R
echo -e $B2"#  ###                  ### ######################## ########################  #"$R
echo -e $B2"#                       ###                     #### ###                 ####  #"$R
echo -e $B2"#  ###                  ###                      ### ###                  ###  #"$R
echo -e $B2"#  ########################  ####################### ###                  ###  #"$R
echo -e $B3"#  ######################## ######################## ###                  ###  #"$R
echo -e $B3"#  ###                  ### ###                  ### ###                  ###  #"$R
echo -e $B3"#  ###                  ### ###                  ### ###                 ####  #"$R
echo -e $B3"#  ###                  ### ######################## ########################  #"$R
echo -e $B4"#  ###                  ###  ####################### ######################    #"$R
echo -e $B4"#                                                                              #"$R
echo -e $B4"#                          $Ba www.i-have-a-dreambox.com $Bb                         #"$R
echo -e $B4" ############################################################################## "$R
}
##############################################################################################################################################################
_which()
{
	which $1 2> /dev/null
#	type -p $1
}
###############################################################################
_get_parameter()
{
local	i=1
local	param=""
local	distri=""
local	result=""
	while [ : ]
	do
		param=`echo $1 | $CUT -f$i -d ":"`
		i=`expr $i + 1`
		distri=`echo $1 | $CUT -f$i -s -d ":"`
		i=`expr $i + 1`
		if (test "$param" = "") then break; fi;
		result=$param
		if (test "$distri" = "") then break; fi;
		if (test "$distri" = "$LINUX_DISTRIBUTION") then break; fi;
		if (test "$distri" = "*") then break; fi;
	done
	echo $result
}
###############################################################################
_update()
{
    mkdir -p tiudir
#    cd tiudir
    if ( test $? -ne 0 ) then
	echo "konnte temporäres Verzeichnis für Update nicht anlegen"
        exit 1
    fi; 
    cd tiudir
    wget http://blue-panel.com/install.sh
    cd ..
    if ( test $? -ne 0 ) then
	echo "konnte install.sh nicht downloaden"
        exit 1
    fi; 
    chmod +x tiudir/install.sh

    MIN_VERSION=`./tiudir/install.sh --version 2>&1 | $GREP -i "install.sh" | $CUT -f3 -d " "`
    CURRENT_VERSION=$INSTALL_VERSION
    i=1
    while [ : ]
    do
    	#Buchstaben von Patchversionen abschneiden (kann ich noch nicht vergleichen -> todo)
	a=`echo $CURRENT_VERSION  | $CUT -f$i -d "."| sed -e 's/[a-zA-Z,]//g'`
	b=`echo $MIN_VERSION  | $CUT -f$i -d "."| sed -e 's/[a-zA-Z,]//g'`
	a1=$a
	b1=$b
	if (test "$a1" = "") then a1="0"; fi;
	if (test "$b1" = "") then b1="0"; fi;
	if [ $a1 -lt $b1 ]; then
    	    echo "update..."
		mv tiudir/install.sh install.sh
		break
	else if [ $a1 -gt $b1 ]; then
	    echo "keine neuere install.sh gefunden"
	    break
	    fi;
	fi;
	if (test "$a" = "") then
	    echo "keine neuere install.sh gefunden"
	    break
	fi;
	if (test "$b" = "") then
	    echo "keine neuere install.sh gefunden"
	    break
	fi;
	i=`expr $i + 1`
    done
rm -fr tiudir
echo -e $ANSI_GREEN"fertig\a"$ANSI_RESET2
sleep 1
echo -e "\a"
sleep 1
echo -e "\a"

}
###############################################################################
_check_uid()
{
	if [ ! `id -u` == "0" ]; then
		echo -e $ANSI_RED"\nkeine Rootrechte\n"$ANSI_RESET
	else
		echo -e $ANSI_GREEN"\033[37;32m\nok,we are root :)\n"$ANSI_RESET
	fi
}
###############################################################################
_get_linuxdistribution()
{
	local TEMP=""
	local LINUX_DISTRIBUTION=""

	for LINUX_DISTRIBUTION in "Debian" "Mandrake" "Mandriva" "Red Hat" "SuSE" "Ubuntu" "unknown"
	do
		TMP=`cat /proc/version | $GREP -i "$LINUX_DISTRIBUTION"`
		if (test "$TMP" != "") then
			LINUX_DISTRIBUTION=`echo $LINUX_DISTRIBUTION | sed -e 's/[ ]//g'`
			break
		fi;
	done
	echo $LINUX_DISTRIBUTION
}
###############################################################################
# ist apt-get installiert und existiert /ets/apt/sources.list, dann benutze apt-get
# ist yast installiert, dann benutze yast
# ist yum installiert und existiert /etc/yum.repos.d , dann benutze yum
_setinstallcmd()
{

YUM=$(_which yum)
APTGET=$(_which apt-get)
YAST=$(_which yast)
URPMI=$(_which urpmi)

if ( test "$APTGET" != "" ) then
	echo "apt-get gefunden"
	if ( test ! -s /ets/apt/sources.list ) then
		echo "sources.list gefunden"
		INSTALL_CMD="$APTGET -y --force-yes install "
		REMOVE_CMD="$APTGET -y remove "
		UPDATE_CMD="$APTGET -y update"
		UPTODATE=""
	fi;
elif ( test "$YUM" != "" ) then
	echo "yum gefunden"
	if ( test ! -s etc/yum.repos.d ) then
		echo "yum.repos.d gefunden"
		INSTALL_CMD="$YUM -y install"
		UPDATE_CMD=""
		UPTODATE="y"
	fi;
elif ( test "$YAST" != "" ) then
	echo "yast gefunden"
	INSTALL_CMD="$YAST -i "
	UPDATE_CMD=""
	UPTODATE="y"
elif ( test "$URPMI" != "" ) then
	echo "urpmi gefunden"
	INSTALL_CMD="$URPMI "
	UPDATE_CMD=""
	UPTODATE="y"
else
	echo -e $ANSI_RED"keine Packetverwaltung (apt-get, yum, yast, urpmi) gefunden"$ANSI_RESET
	exit 72		#Code für: wichtige Systemdatei fehlt
fi;	
}
###############################################################################
_doasroot()
{
_check_uid

LINUX_DISTRIBUTION=$(_get_linuxdistribution)

echo $LINUX_DISTRIBUTION

###############################################################################
_setinstallcmd
##########################################################
#zuerst dafür sorgen, dass bash als Shell gesetzt ist
##########################################################
TMP=`ls -l /bin/sh | $GREP "bash"`
if ( test "$TMP" != "") then
	echo "bash ist korrekt gesetzt"
else
	echo "bash wird gesetzt"
	TMP=`whereis bash | $GREP "/bin/bash"`
	echo $TMP
	if (test "$TMP" != "") then
		echo "bash ist installiert"
	else
		echo "installiere bash"
		$INSTALL_CMD bash
	fi;
	echo "verlinke bash"
	rm -f /bin/sh
	ln -s /bin/bash /bin/sh	# ln -f gibt es nicht immer, deswegen vorher rm
	./install.sh --install-tools
	exit
fi;

##########################################################
echo "Teste rsh"
TMP=`type -p rsh`
if ( test "$TMP" != "") then
	echo "rsh ok"
else
	echo "rsh wird verlinkt"
	SSHPATH=`type -p ssh | $GREP "/bin/ssh"`
	echo $SSHPATH
	if (test "$SSHPATH" != "") then
		echo "ssh ist installiert"
	else
		echo "installiere ssh"
		$INSTALL_CMD ssh
	fi;
	echo "verlinke rsh"
	SSHPATH=`type -p ssh | $GREP "/bin/ssh"`
	if (test "$SSHPATH" != "") then
		rm -f /bin/rsh
		ln -s $SSHPATH /bin/rsh		# ln -f gibt es nicht immer, deswegen vorher rm
	else
		echo "rsh konnte nicht verlinkt werden"
	fi;
fi;

##########################################################
# nötige Libraries für "enigma2 on pc" installieren
##########################################################
#TODO!!!! das ist im Moment nur für Linux mit apt-get getestet!!!
	if [ ! `id -u` == "0" ]; then
		echo -e "\a"
	fi;
	sudo $INSTALL_CMD \
		python-pysqlite2\
		libfribidi-dev \
		libid3tag0-dev \
		libmad0-dev \
		libsigc++-1.2-dev \
		libungif4-dev \
		libpng12-dev \
		libjpeg-dev \
		libcurl4-openssl-dev \
		libcurl3-openssl-dev \
		libxml2-dev \
		libxslt1-dev \
		libexpat-dev \
		libfreetype6-dev
	if ( test $? -ne 0 ) then 
		echo -e $ANSI_YELLOW"Fehler beim installieren der Libraries"$ANSI_RESET2
		for todo in "libfribidi-dev" \
		"python-pysqlite2" \
		"libid3tag0-dev" \
		"libmad0-dev" \
		"libsigc++-1.2-dev" \
		"libungif4-dev" \
		"libpng12-dev" \
		"libjpeg-dev" \
		"libcurl4-openssl-dev" \
		"libcurl2-openssl-dev" \
		"libxml2-dev" \
		"libxslt1-dev" \
		"libexpat-dev" \
		"libfreetype6-dev"
		do
			if [ ! `id -u` == "0" ]; then
				echo -e "\a"
			fi;
			sudo $INSTALL_CMD $todo
			if ( test $? -ne 0 ) then 
				echo -e $ANSI_YELLOW"Fehler beim installieren der Libary $todo"$ANSI_RESET2
			fi;
		done
	fi;
##########################################################
#Sourceliste checken
#	sed -e '/http:/s/# deb/deb/g' /etc/apt/sources.list > /tmp/test
#	sudo cp /etc/apt/sources.list /etc/apt/sources.list.bak
#	sudo mv /tmp/test /etc/apt/sources.list

##########################################################
#Tools prüfen und installieren

#Aufbau von TOOLPARAMETER am Beispiel für makeinfo
# Name des Tool									makeinfo
# Kommando zum erfragen der Version						--version
# ein (ein einziges!) Erkennungswort das in der Zeile mit der Versionsausgabe vorkommen muss	makeinfo
# die Position an der die Versionsnummer in dieser Zeile steht			4
# die Version, die mindestens installiert sein muss				0
# Package-Name, wenn dieser anders als der Toolname ist (z.B. bei makeinfo)	texinfo

for TOOLPARAMETER in \
	"mc --version Commander 4 0" \
	"cvs --version Concurrent 5 1.12.12" \
	"autoconf --version autoconf 4 2.57a" \
	"automake --version automake 4 1.10" \
	"libtool --version libtool 4 1.4.2" \
	"gettext --version gettext 4 0.17" \
	"make --version Make 3 3.79" \
	"makeinfo --version makeinfo 4 0 texinfo" \
	"tar --version tar 4 0" \
	"gunzip --version gzip 2 0" \
	"patch --version patch 2 0" \
	"infocmp -V ncurses 2 0 ncurses-devel:SuSE:ncurses-bin" \
	"gcc --version gcc 4:SuSE:3 3.0" \
	"g++ --version g++ 4:SuSE:3 3.0 gcc-c++:SuSE:gcc-c++:RedHat:g++" \
	"bison --version Bison 4 0" \
	"pkg-config --version '' 1 0.2" \
	"wget --version Wget 3 0" \
	"help2man --version help2man 3 0" \
	"diffstat --version diffstat 3 0" \
	"texi2html --version '' 1 0" \
	"gawk --version Awk 3 0" \
	"gettext --version gettext 4 0" \
	"bunzip2 --version Version 8 0 bzip2" \
	"python -V Python 2 2.4.3" \
	"uudecode --version sharutils 4 0 sharutils" \
	"swig -version Version 3 1.3.36" \
	"flex --version flex 2 2.3" \
	"asciidoc --version asciidoc 2 8.2.2" \
	"xmlto --version version 3 0.0.18" \
	"db2x_xsltproc --version docbook2X 5 0.8.7 docbook2x" \
	"svn --version Version 3 0 subversion"

#todo
###psyco jit compiler

do
	TOOL=`echo $TOOLPARAMETER | $CUT -f 1 -d " "`
	VERSION_CMD=`echo $TOOLPARAMETER | $CUT -f 2 -d " "`
	SEARCHPATTERN=`echo $TOOLPARAMETER | $CUT -f 3 -d " "`
	TMP=`echo $TOOLPARAMETER | $CUT -f 4 -d " "`
	POSITION=`_get_parameter $TMP`
	MIN_VERSION=`echo $TOOLPARAMETER | $CUT -f 5 -d " "`

	TMP=`echo $TOOLPARAMETER | $CUT -f 6 -d " "`
	if (test "$TMP" = "") then
		INSTALL_PACKAGE=$TOOL
	else
		INSTALL_PACKAGE=`_get_parameter $TMP`
	fi;

#	echo $TOOL $VERSION_CMD
	TOOLPATH=`_which $TOOL`
	if (test "$TOOLPATH" != "") then
		if (test "$SEARCHPATTERN" != "''") then
			CURRENT_VERSION=`$TOOL $VERSION_CMD 2>&1 | $GREP -i "$SEARCHPATTERN" | $CUT -f$POSITION -d " "`
		else
			CURRENT_VERSION=`$TOOL $VERSION_CMD 2>&1`
		fi;
		CURRENT_VERSION=`echo $CURRENT_VERSION | $CUT -f 1 -d " "| sed -e 's/[,;()]//g'`
		echo "$TOOL: "$CURRENT_VERSION
		i=1
		while [ : ]
		do
			#Buchstaben von Patchversionen abschneiden (kann ich noch nicht vergleichen -> todo)
			a=`echo $CURRENT_VERSION  | $CUT -f$i -d "."| sed -e 's/[a-zA-Z,]//g'`
			b=`echo $MIN_VERSION  | $CUT -f$i -d "."| sed -e 's/[a-zA-Z,]//g'`
			a1=$a
			b1=$b
			if (test "$a1" = "") then a1="0"; fi;
			if (test "$b1" = "") then b1="0"; fi;
			if [ $a1 -lt $b1 ]; then
				echo "$CURRENT_VERSION < $MIN_VERSION"
				echo "Version veraltet"
				echo "update"
				if (test "$UPTODATE" != "y"); then
					UPTODATE="y"
					$UPDATE_CMD
				fi;
				$INSTALL_CMD $INSTALL_PACKAGE
				break
			else if [ $a1 -gt $b1 ]; then break; fi;
			fi;
			if (test "$a" = "") then break; fi;
			if (test "$b" = "") then break; fi;
			i=`expr $i + 1`
		done
	else
		echo "installiere Package $INSTALL_PACKAGE für Tool $TOOL"
		if (test "$UPTODATE" != "y"); then
			UPTODATE="y"
			$UPDATE_CMD
		fi;
		$INSTALL_CMD $INSTALL_PACKAGE
		#Kontrolle, ob das Tool nun installiert ist
		TOOLPATH=`_which $TOOL`
		if (test "$TOOLPATH" != "") then
			echo "$TOOL: "`$TOOL $VERSION_CMD | $GREP $SEARCHPATTERN | $CUT -f$POSITION -d " "`
		else
			echo -e "\033[37;41m$TOOL lies sich nicht installieren.\033[37;0m"
			exit 72
		fi;
	fi;
done
exit 0
}
###############################################################################
###############################################################################
INIT_DIR=$PWD
CUT=`_which cut`
GREP=`_which grep`
SUDO=`_which sudo`
###############################################################################
_ihad_logo
if (test "$#" -ge 2) then
	echo "install.sh Version $INSTALL_VERSION"
	exit
fi;

if (test "$#" = 1) then
	case $1 in
	'--update')
			_update
			exit;;
	'--install-tools')
			_doasroot
			exit;;
	'--version')	echo "install.sh Version $INSTALL_VERSION"
			exit;;
	*)		echo "install.sh Version $INSTALL_VERSION"
			echo "helptext blablabla"
			exit;;
	esac
fi;

if [ ! `id -u` == "0" ]; then
	echo -e "\a"
fi;
if ( test "$SUDO" = "") then
	su -c "./install.sh --install-tools"
	installresult=$?
else
	sudo  ./install.sh --install-tools
	installresult=$?
	sudo -k
		if ( test "$installresult" = 1 ) then
			echo -e "\nHmm...,\nalso wenn 'sudo' nicht geht, dann versuchen wir es doch mal mit 'su' ;)\n"
			su -c "./install.sh --install-tools"
			installresult=$?
		fi;
fi;
if ( test "$installresult" -ne 0 ) then
	echo "Abbruch"
	exit
fi;
################################################################################################################
################################################################################################################
cd $INIT_DIR
mkdir -p cvs
cd cvs
CVS_ROOT=$PWD
for old_db in "dm500" "dm7000" "dm56x0"
do
	filename="make_$old_db"
	cd $CVS_ROOT
	mkdir -p $old_db
	cd $old_db
	echo '#!/bin/sh' > $filename
	echo 'export CVS_RSH=ssh' >> $filename
	echo 'cvs -d anoncvs@cvs.tuxbox.org:/cvs/tuxbox -z3 co -P -rdreambox .' >> $filename
	echo 'cd cdk' >> $filename
	echo 'chmod ugo+x prepare' >> $filename
	echo "./prepare $old_db" >> $filename
	echo 'make checkout' >> $filename
	echo 'make dreamboximage_root' >> $filename
	echo 'make rebuild-flash' >> $filename
	echo 'make flash-compress' >> $filename
	chmod 755 $filename
	cd $OLDPWD
done
################################################################################################################
cd $INIT_DIR
mkdir -p openembedded
cd openembedded
OE_ROOT=$PWD
#------------------------------------------------------------------------------
#Bitbake holen und für den Gebrauch in Python 2.6 patchen
mkdir -p bb
cd bb
SVN_BITBAKE_PARENT="svn://svn.berlios.de/bitbake/"
for BB_VERSION in "1.6.8" "1.8.12"
do
	echo "download bitbake-${BB_VERSION}"
	svn checkout ${SVN_BITBAKE_PARENT}/tags/bitbake-${BB_VERSION} ${BB_VERSION}
	if ( test $? -ne 0 ) then
		wget http://download.berlios.de/bitbake/bitbake-${BB_VERSION}.tar.gz
		if ( test $? -ne 0 ) then
			wget http://download2.berlios.de/bitbake/bitbake-${BB_VERSION}.tar.gz
			if ( test $? -ne 0 ) then
				echo -e $ANSI_RED"Fehler beim downloaden von bitbake-${BB_VERSION}"$ANSI_RESET2
				exit 72		#Code für: wichtige Systemdatei fehlt
			fi;
		fi;
		tar xvfz bitbake-${BB_VERSION}.tar.gz
		mv bitbake-${BB_VERSION} ${BB_VERSION}
	fi;
	echo "patch bitbake-${BB_VERSION}"
	if ( test -d ${BB_VERSION} ) then
		rm -fr ${BB_VERSION}a
		cp -r ${BB_VERSION} ${BB_VERSION}a
		CUT1CMD="1,/start-file-${BB_VERSION}a/ d"
		CUT2CMD="/end-file-${BB_VERSION}a/,$ d"
		sed -e "$CUT1CMD" -e "$CUT2CMD" < $INIT_DIR/install.sh | uudecode -o ${BB_VERSION}a.diff
		patch -Nsp1 -d ${BB_VERSION}a < ${BB_VERSION}a.diff
	else
		echo -e $ANSI_RED"konnte Verzeichnis $PWD/${BB_VERSION} nicht finden"$ANSI_RESET2
		exit 72		#Code für: wichtige Systemdatei fehlt
	fi;
done
cd ${OE_ROOT}
#------------------------------------------------------------------------------
#Python-Version testen
PYTHON_VERSION=`python -V 2>&1 | $GREP -i "Python" | $CUT -f2 -d " "`
if [ `echo $PYTHON_VERSION |$CUT -f1 -d "."` -gt 2 ]; then
	echo -e "Python $PYTHON_VERSION wird möglicherweise nicht unterstützt\nDie letzte getestete Version war Python 2.6"
	USE_BB_PATCH="y"
fi;
if [ `echo $PYTHON_VERSION |$CUT -f1 -d "."` = 2 ]; then
	if [ `echo $PYTHON_VERSION |$CUT -f2 -d "."` -gt 5 ]; then
		USE_BB_PATCH="y"
	fi;
fi;
#------------------------------------------------------------------------------
#neues gettext bauen
_setinstallcmd
GETTEXT_PATH=`_which gettext`
if ( test "$GETTEXT_PATH" = "") then
	GETTEXT_VERSION="0"
else
	GETTEXT_VERSION=`gettext --version 2>&1 | $GREP -i "gettext" | $CUT -f4 -d " "`
fi;
GETTEXT_REQUEST='0.17'
echo $GETTEXT_VERSION

CURRENT_VERSION=$GETTEXT_VERSION
MIN_VERSION=$GETTEXT_REQUEST
	i=1
	while [ : ]
	do
		#Buchstaben von Patchversionen abschneiden (kann ich noch nicht vergleichen -> todo)
		a=`echo $CURRENT_VERSION  | $CUT -f$i -d "."| sed -e 's/[a-zA-Z,]//g'`
		b=`echo $MIN_VERSION  | $CUT -f$i -d "."| sed -e 's/[a-zA-Z,]//g'`
		a1=$a
		b1=$b
		if (test "$a1" = "") then a1="0"; fi;
		if (test "$b1" = "") then b1="0"; fi;
		if [ $a1 -lt $b1 ]; then
			echo "$CURRENT_VERSION < $MIN_VERSION"
			echo "Version veraltet"
			echo "update"
			#;.................................................
			mkdir -p gettext
			cd gettext
			wget http://ftp.gnu.org/pub/gnu/gettext/gettext-${GETTEXT_REQUEST}.tar.gz
			if ( test $? -ne 0 ) then 
				echo "konnte gettext Source nicht downloaden"
				exit 72
			fi;
			tar xvfz gettext-${GETTEXT_REQUEST}.tar.gz
			if ( test $? -ne 0 ) then 
				echo "konnte gettext Source nicht entpacken"
				exit 72
			fi;
			cd gettext-${GETTEXT_REQUEST}

			./configure
			make
			echo -e $ANSI_GREEN"\ninstalliere gettext"$ANSI_RESET2
			if [ ! `id -u` == "0" ]; then
				echo -e "\a"
			fi;
			sudo make install
			cd ..
			break
		else if [ $a1 -gt $b1 ]; then break; fi;
		fi;
		if (test "$a" = "") then break; fi;
		if (test "$b" = "") then break; fi;
		i=`expr $i + 1`
	done
#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
#neues git bauen
_setinstallcmd
GIT_PATH=`_which git`
if ( test "$GIT_PATH" = "") then
	GIT_VERSION="0"
	if [ ! `id -u` == "0" ]; then
		echo -e "\a"
	fi;
	sudo $INSTALL_CMD libssl-dev 
	if [ ! `id -u` == "0" ]; then
		echo -e "\a"
	fi;
	sudo $INSTALL_CMD libcurl3-dev
else
	GIT_VERSION=`git --version 2>&1 | $GREP -i "git" | $CUT -f3 -d " "`
fi;
GIT_REQUEST='1.6.3.2'
echo $GIT_VERSION

CURRENT_VERSION=$GIT_VERSION
MIN_VERSION=$GIT_REQUEST
	i=1
	while [ : ]
	do
		#Buchstaben von Patchversionen abschneiden (kann ich noch nicht vergleichen -> todo)
		a=`echo $CURRENT_VERSION  | $CUT -f$i -d "."| sed -e 's/[a-zA-Z,]//g'`
		b=`echo $MIN_VERSION  | $CUT -f$i -d "."| sed -e 's/[a-zA-Z,]//g'`
		a1=$a
		b1=$b
		if (test "$a1" = "") then a1="0"; fi;
		if (test "$b1" = "") then b1="0"; fi;
		if [ $a1 -lt $b1 ]; then
			echo "$CURRENT_VERSION < $MIN_VERSION"
			echo "Version veraltet"
			echo "update"
			#;.................................................
			# wir hholen das git über das http-Protokoll , weil das auch hinter Firewalls immer geht
			echo "erste Variante: http"
			git clone http://www.kernel.org/pub/scm/git/git.git
			if ( test $? -ne 0 ) then 
				echo "zweite Variante: git"
				git clone git://git.kernel.org/pub/scm/git/git.git
				if ( test $? -ne 0 ) then 
					echo "dritte Variante: source"
					mkdir -p git
					cd git
					wget http://kernel.org/pub/software/scm/git/git-${GIT_REQUEST}.tar.gz
					if ( test $? -ne 0 ) then 
						echo "konnte git Source nicht downloaden"
						exit 72
					fi;
					tar xvfz git-${GIT_REQUEST}.tar.gz
					if ( test $? -ne 0 ) then 
						echo "konnte git Source nicht entpacken"
						exit 72
					fi;
					cd git-${GIT_REQUEST}
				fi;
			fi;

			if [ ! `id -u` == "0" ]; then
				echo -e "\a"
			fi;
			sudo $REMOVE_CMD git git-core

			if ( test ! -d "git" ) then
				if ( test ! -d "git-${GIT_REQUEST}.tar.gz" ) then
					echo "vierte Variante: source"
					mkdir -p git
					cd git
					wget http://kernel.org/pub/software/scm/git/git-${GIT_REQUEST}.tar.gz
					if ( test $? -ne 0 ) then 
						echo "konnte git Source nicht downloaden"
						exit 72
					fi;
					tar xvfz git-${GIT_REQUEST}.tar.gz
					if ( test $? -ne 0 ) then 
						echo "konnte git Source nicht entpacken"
						exit 72
					fi;
					cd git-${GIT_REQUEST}
				fi;
			fi;

			cd git
#			make prefix=/usr all doc info
			make prefix=/usr all
			echo -e $ANSI_GREEN"\ninstalliere git"$ANSI_RESET2
#			sudo make prefix=/usr install install-doc install-html install-info
			if [ ! `id -u` == "0" ]; then
				echo -e "\a"
			fi;
			sudo make prefix=/usr install
			cd ..
			#rm -rf git
			#;.................................................
			break
		else if [ $a1 -gt $b1 ]; then break; fi;
		fi;
		if (test "$a" = "") then break; fi;
		if (test "$b" = "") then break; fi;
		i=`expr $i + 1`
	done
#------------------------------------------------------------------------------
for DISTRO_VERSION in "1.5" "1.6"
do
	cd $OE_ROOT
	mkdir -p $DISTRO_VERSION
	cd $DISTRO_VERSION
   	case $DISTRO_VERSION in
		1.5) 	BRANCH="org.openembedded.dreambox"
#			if [ $USE_BB_PATCH = "y" ]; then
				BB_VERSION="1.6.8a"
				PACKAGES="packages"
#			else
#				BB_VERSION="1.6.8"
#			fi;
			GIT_URL="git://git.openembedded.net/openembedded";;
		1.6) 	BRANCH="opendreambox"
#			if [ $USE_BB_PATCH = "y" ]; then
				BB_VERSION="1.8.12a"
				PACKAGES="recipes"
#			else
#				BB_VERSION="1.8.12"
#			fi;
			GIT_URL="git://git.opendreambox.org/git/openembedded";;
	esac
	for MACHINE in "dm500hd" "dm500plus" "dm600pvr" "dm7020" "dm7025" "dm800" "dm8000"
	do
		mkdir -p $MACHINE
		cd $MACHINE
		for FILE in build/env.source build/conf/local.conf
		do
			if ( test -f $FILE ) then
				if ( test -s $FILE ) then
					cp $FILE "$FILE$(date "+.backup_%Y%m%d%S")"
				fi;
				rm -f $FILE
			fi;
		done

		echo '#!/usr/bin/make -f' > Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo '# target platform: dm500hd, dm500plus, dm600pvr, dm7020, dm7025, dm800, dm8000' >> Makefile-opendreambox
		echo 'MACHINE = '$MACHINE >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo '# for a list of some other repositories have' >> Makefile-opendreambox
		echo '# a look at http://git.opendreambox.org/' >> Makefile-opendreambox
		echo 'GIT_URL = '$GIT_URL >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo '# in case you want to send pull requests or generate patches' >> Makefile-opendreambox
		echo '#GIT_AUTHOR_NAME ?= xyz' >> Makefile-opendreambox
		echo '#GIT_AUTHOR_EMAIL ?= xyz@mail.net' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo "# uncomment this if you're upgrading an installation" >> Makefile-opendreambox
		echo '# from monotone. this changes the directory layout' >> Makefile-opendreambox
		echo '# to the old version without shared directories.' >> Makefile-opendreambox
		echo '#UPGRADE_FROM_MONOTONE=1' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo '# you should not need to change anything below' >> Makefile-opendreambox
		echo 'BB_VERSION = '$BB_VERSION >> Makefile-opendreambox
		echo 'SVN = svn' >> Makefile-opendreambox
		echo 'SVN_BITBAKE_PARENT = "svn://svn.berlios.de/bitbake/"' >> Makefile-opendreambox
		echo 'DISTRO_VERSION = '$DISTRO_VERSION >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo 'GIT = git' >> Makefile-opendreambox
		echo 'GIT_BRANCH = '$BRANCH >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo 'CPU_COUNT := $(shell grep processor /proc/cpuinfo | wc -l)' >> Makefile-opendreambox
		echo 'PWD := $(shell pwd)' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo 'OE_ROOT:='$OE_ROOT >> Makefile-opendreambox
		echo 'OE_BASE = $(PWD)' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo 'all: initialize' >> Makefile-opendreambox
		echo '	@echo ' >> Makefile-opendreambox
		echo '	@echo "Openembedded for the Dreambox environment has been initialized"' >> Makefile-opendreambox
		echo '	@echo "properly. Now you can either:"' >> Makefile-opendreambox
		echo '	@echo' >> Makefile-opendreambox
		echo '	@echo "  - make the 'image'-target to build an image, or"' >> Makefile-opendreambox
		echo '	@echo "  - go into $(MACHINE)/build/, source env.source and start on your own!"' >> Makefile-opendreambox
		echo '	@echo ' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
#		echo 'bb:' >> Makefile-opendreambox
#		echo '# das echo " " verhindert, dass wenn das checkout fehlschlägt, das Script abbricht' >> Makefile-opendreambox
#		echo '	${SVN} checkout ${SVN_BITBAKE_PARENT}/tags/bitbake-${BB_VERSION} ${OE_ROOT}/bb/${BB_VERSION}; echo " "' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo '.PHONY: image initialize openembedded-update' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo 'image: initialize openembedded-update' >> Makefile-opendreambox
		echo '	cd build; . ./env.source; bitbake dreambox-image' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
#		echo 'initialize: cache build build/conf build/conf/local.conf build/env.source bb ${OE_ROOT}/${DISTRO_VERSION}/openembedded' >> Makefile-opendreambox
		echo 'initialize: cache build build/conf build/conf/local.conf build/env.source ${OE_ROOT}/${DISTRO_VERSION}/openembedded' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo 'openembedded-update: ${OE_ROOT}/${DISTRO_VERSION}/openembedded' >> Makefile-opendreambox
		echo '	cd ${OE_ROOT}/${DISTRO_VERSION}/openembedded && $(GIT) pull' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo 'cache build/conf build:' >> Makefile-opendreambox
		echo '	mkdir -p $@' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo 'build/conf/local.conf:' >> Makefile-opendreambox
		echo "	echo 'DL_DIR = \"\$(OE_ROOT)/sources\"' > \$@" >> Makefile-opendreambox
		echo "	echo 'OE_BASE = \"\$(PWD)\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'BBFILES = \"\${OE_ROOT}/\${DISTRO_VERSION}/openembedded/${PACKAGES}/*/*.bb\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'BBMASK = \"(nslu.*|.*-sdk.*)\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'PREFERRED_PROVIDERS += \" virtual/\$\${TARGET_PREFIX}gcc-initial:gcc-cross-initial\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'PREFERRED_PROVIDERS += \" virtual/\$\${TARGET_PREFIX}gcc:gcc-cross\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'PREFERRED_PROVIDERS += \" virtual/\$\${TARGET_PREFIX}g++:gcc-cross\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'MACHINE = \"\$(MACHINE)\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'TARGET_OS = \"linux\"' >> \$@" >> Makefile-opendreambox
		case $DISTRO_VERSION in
			1.5)	echo "	echo 'DISTRO = \"opendreambox-\${DISTRO_VERSION}\"' >> \$@" >> Makefile-opendreambox;;
			1.6)	echo "	echo 'DISTRO = \"opendreambox\"' >> \$@" >> Makefile-opendreambox;;
		esac
		echo "	echo 'CACHE = \"\$(OE_BASE)/cache/oe-cache.\$\${USER}\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'OE_ALLOW_INSECURE_DOWNLOADS = \"1\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'BB_NUMBER_THREADS = \"\$(CPU_COUNT)\"' >> \$@" >> Makefile-opendreambox

		echo '' >> Makefile-opendreambox
		echo 'build/env.source:' >> Makefile-opendreambox
		echo "	echo 'OE_ROOT=\${OE_ROOT}' > \$@" >> Makefile-opendreambox
		echo "	echo 'OE_BASE=\$(PWD)' >> \$@" >> Makefile-opendreambox
		echo "	echo 'export BBPATH=\"\$\${OE_ROOT}/\${DISTRO_VERSION}/openembedded/:\$\${OE_ROOT}/bb/\${BB_VERSION}/:\$\${OE_BASE}/build/\"' >> \$@" >> Makefile-opendreambox
		echo "	echo 'PATH=\$\${OE_ROOT}/bb/\${BB_VERSION}/bin:\$\${OE_BASE}/build/tmp/cross/bin:\$\${PATH}' >> \$@" >> Makefile-opendreambox
		echo "	echo 'export PATH' >> \$@" >> Makefile-opendreambox
		echo "	echo 'export LD_LIBRARY_PATH=' >> \$@" >> Makefile-opendreambox
		echo "	echo 'export LANG=C' >> \$@" >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo '${OE_ROOT}/${DISTRO_VERSION}/openembedded: ${OE_ROOT}/${DISTRO_VERSION}/openembedded/.git' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox
		echo '${OE_ROOT}/${DISTRO_VERSION}/openembedded/.git:' >> Makefile-opendreambox
		echo '	@if [ -d $(OE_ROOT)/${DISTRO_VERSION}/openembedded/_MTN ]; then echo "Please remove your old monotone repository from $(OE_ROOT)/${DISTRO_VERSION}/openembedded!"; exit 1; fi' >> Makefile-opendreambox
		echo '	$(GIT) clone -n $(GIT_URL) $(OE_ROOT)/${DISTRO_VERSION}/openembedded' >> Makefile-opendreambox
		echo '	cd $(OE_ROOT)/${DISTRO_VERSION}/openembedded && ( \' >> Makefile-opendreambox
		echo '		if [ -n "$(GIT_AUTHOR_EMAIL)" ]; then git config user.email "$(GIT_AUTHOR_EMAIL)"; fi; \' >> Makefile-opendreambox
		echo '		if [ -n "$(GIT_AUTHOR_NAME)" ]; then git config user.name "$(GIT_AUTHOR_NAME)"; fi; \' >> Makefile-opendreambox
		echo '		$(GIT) branch $(GIT_BRANCH) origin/$(GIT_BRANCH) || true; \' >> Makefile-opendreambox
		echo '		$(GIT) checkout $(GIT_BRANCH) \' >> Makefile-opendreambox
		echo '	)' >> Makefile-opendreambox
		echo '' >> Makefile-opendreambox

		filename="make_$MACHINE"
		echo '#!/bin/sh' > $filename
		echo 'make -f Makefile-opendreambox image' >> $filename
		chmod 755 $filename

		filename="make_tomorrow_$MACHINE"
		echo '#!/bin/sh' > $filename
		echo '#Diese Script setzt SRCDATE auf das morgige Datum und baut ein Image' >> $filename
		echo '' >> $filename
		echo '#Eine Liste der Verzeichnisse aus /obenembedded/packages, die aktuallisiert werden soll' >> $filename
		echo '#PACKAGES="enigma2 tuxbox libdreamdvd"' >> $filename
		echo 'PACKAGES="enigma2 libdreamdvd aio-grab"' >> $filename
		echo '' >> $filename
		echo 'OLDDIR=$PWD' >> $filename
		echo 'OE_ROOT=`cat Makefile-opendreambox |grep -m 1 OE_ROOT | cut -f2 -d "="`' >> $filename
		echo "DISTRO_VERSION=\`cat Makefile-opendreambox |grep -m 1 DISTRO_VERSION | cut -f2 -d \"=\"|sed -e 's/[ ]//g'\`" >> $filename
		echo 'TEMP=`cat Makefile-opendreambox |grep -m 1 openembedded-update: | cut -f2 -d ":"`' >> $filename
		echo 'OE_DIR=`eval echo $TEMP/packages`' >> $filename
		echo 'if ( test ! -d $OE_DIR ) then' >> $filename
		echo '	echo "Fehler: Konnte das Verzeichnis $OE_DIR nicht finden"' >> $filename
		echo '	exit 1' >> $filename
		echo 'fi;' >> $filename
		echo 'echo $OE_DIR' >> $filename
		echo 'cd $OE_DIR' >> $filename
		echo '' >> $filename
		echo 'TEMPFILE=`mktemp`' >> $filename
		echo 'if ( test ! -f $TEMPFILE ) then' >> $filename
		echo '	echo "Fehler: Konnte kein temporäres File erstellen"' >> $filename
		echo 'exit 1' >> $filename
		echo 'fi;' >> $filename
		echo 'TOMORROW=`date -d tomorrow "+%Y%m%d"`' >> $filename
		echo 'SEDCMDSTRING=/SRCDATE/s/"[12][09][0-9][0-9][01][0-9][0-3][0-9]"/$TOMORROW/' >> $filename
		echo 'for PACKAGE in $PACKAGES' >> $filename
		echo 'do' >> $filename
		echo '	for FILE in $PACKAGE/*.bb' >> $filename
		echo '	do' >> $filename
		echo "		TEMP=\`cat \$FILE | grep SRCDATE| grep -m 1 \"[12][09][0-9][0-9][01][0-9][0-3][0-9]\"| sed -e 's/[a-zA-Z\"=]//g'\`" >> $filename
		echo '		if (test "$TEMP" != "") then' >> $filename
		echo '			if [ $TEMP -ne $TOMORROW ]; then' >> $filename
		echo '				sed -e "$SEDCMDSTRING" <$FILE	>$TEMPFILE' >> $filename
		echo '				cp $FILE "$FILE$(date "+.backup_%Y%m%d%S")"' >> $filename
		echo '				mv $TEMPFILE $FILE' >> $filename
		echo '			fi;' >> $filename
		echo '		fi;' >> $filename
		echo '	done' >> $filename
		echo 'done' >> $filename
		echo 'rm -f $TEMPFILE' >> $filename
		echo 'cd $OLDDIR' >> $filename
		echo 'make -f Makefile-opendreambox image' >> $filename
		echo '' >> $filename
		chmod 755 $filename


		cd $OLDPWD
	done
done
_ihad_logo
echo -e "\033[37;32mFertig.\nHave fun.\a\033[37;0m"
sleep 1
echo -e "\a"
sleep 1
echo -e "\a"
exit
start-file-1.6.8a
begin-base64 644 1.6.8a.diff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====
end-file-1.6.8a
start-file-1.8.12a
begin-base64 644 1.8.12a.diff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====
end-file-1.8.12a
